/* Copyright (c) 2011  Eric Milles <eric.milles@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef Platform_h
#define Platform_h


#if defined(RSOUTPUT_EXPORTS)
	#define RSOUTPUT_API __declspec(dllexport)
#else
	#define RSOUTPUT_API __declspec(dllimport)
#endif


#include <string>
#include <tchar.h>
#include <windows.h>


// integer types
typedef INT8 int8_t;
typedef UINT8 uint8_t;
typedef INT16 int16_t;
typedef UINT16 uint16_t;
typedef INT32 int32_t;
typedef UINT32 uint32_t;
typedef INT64 int64_t;
typedef UINT64 uint64_t;

// other types
typedef UINT8 byte_t;
typedef TCHAR char_t;
typedef std::basic_string<TCHAR> string_t;


namespace Platform {
namespace Charset {

RSOUTPUT_API void fromUTF8(const std::string& src, std::string& dst);
RSOUTPUT_API void fromUTF8(const std::string& src, std::wstring& dst);
RSOUTPUT_API void toUTF8(const std::string& src, std::string& dst);
RSOUTPUT_API void toUTF8(const std::wstring& src, std::string& dst);

} // namespace Charset

RSOUTPUT_API void centerWindow(HWND);
RSOUTPUT_API void enableWindow(HWND, bool = true);

} // namespace Platform


#endif // Platform_h
