/* Copyright (c) 2011  Eric Milles <eric.milles@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef Device_h
#define Device_h


#include "OutputSink.h"


class Device
:
	public OutputSink
{
public:
	virtual ~Device();

	virtual bool isOpen() const = 0;
	virtual void open() = 0;
	virtual void close() = 0;

	virtual void setBalance(double) = 0;
	virtual void setVolume(double) = 0;

	virtual unsigned int remoteControlId() const = 0;
};


inline Device::~Device()
{
}


#endif // Device_h
