/* Copyright (c) 2011  Eric Milles <eric.milles@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef OutputNotification_h
#define OutputNotification_h


#include <cstddef>
#include <Poco/Notification.h>


class OutputNotification
:
	public Poco::Notification
{
public:
	OutputNotification();

	std::size_t getBytes() const;
	void setBytes(std::size_t);

private:
	std::size_t _bytes;
};


inline OutputNotification::OutputNotification()
:
	_bytes(0)
{
}


inline std::size_t OutputNotification::getBytes() const
{
	return _bytes;
}


inline void OutputNotification::setBytes(const std::size_t bytes)
{
	_bytes = bytes;
}


#endif // OutputNotification_h
