/* Copyright (c) 2011  Eric Milles <eric.milles@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef WinampPlayer_h
#define WinampPlayer_h


#include "Player.h"
#include "Uncopyable.h"


class WinampPlayer
:
	public Player,
	private Uncopyable
{
public:
	explicit WinampPlayer(HWND&);

	HWND window() const;

	void play();
	void pause();
	void stop();
	void skipForward();
	void skipBackward();
	void seekForward();
	void seekBackward();
	void increaseVolume();
	void decreaseVolume();
	void mute();
	void shuffle();

private:
	HWND& _playerWindow;
};


#endif // WinampPlayer_h
