/* Copyright (c) 2011  Eric Milles <eric.milles@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include "XMPlayPlayer.h"


XMPlayPlayer::XMPlayPlayer(XMPFUNC_MISC* const miscFunc)
:
	_miscFunc(miscFunc)
{
}


HWND XMPlayPlayer::window() const
{
	return _miscFunc->GetWindow();
}


void XMPlayPlayer::play()
{
	// perform play/pause shortcut
	_miscFunc->PerformShortcut(80);
}


void XMPlayPlayer::pause()
{
	// perform play/pause shortcut
	_miscFunc->PerformShortcut(80);
}


void XMPlayPlayer::stop()
{
	// perform stop shortcut
	_miscFunc->PerformShortcut(81);
}


void XMPlayPlayer::skipForward()
{
	// perform next track shortcut
	_miscFunc->PerformShortcut(128);
}


void XMPlayPlayer::skipBackward()
{
	// perform previous track shortcut
	_miscFunc->PerformShortcut(129);
}


void XMPlayPlayer::seekForward()
{
	// perform seek forward shortcut
	_miscFunc->PerformShortcut(82);
}


void XMPlayPlayer::seekBackward()
{
	// perform seek backward shortcut
	_miscFunc->PerformShortcut(83);
}


void XMPlayPlayer::increaseVolume()
{
	// perform volume up shortcut (twice); each produces a 2% change in volume
	_miscFunc->PerformShortcut(512);
	_miscFunc->PerformShortcut(512);
}


void XMPlayPlayer::decreaseVolume()
{
	// perform volume down shortcut (twice); each produces a 2% change in volume
	_miscFunc->PerformShortcut(513);
	_miscFunc->PerformShortcut(513);
}


void XMPlayPlayer::mute()
{
	// perform volume down shortcut (50x); each produces a 2% change in volume
	for (int i = 0; i < 50; ++i)
	{
		_miscFunc->PerformShortcut(513);
	}
}


void XMPlayPlayer::shuffle()
{
	// perform toggle random play order shortcut
	_miscFunc->PerformShortcut(313);
}
